#!/usr/local/bin/python

#Copyright (C) 2004  by Phillip Deneault <deneault@hiddengroup.net>

#    This file is part of Placid.

#    Placid is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.

#    Placid is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.

#    You should have received a copy of the GNU General Public License
#    along with Placid; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import sys              #system module
import string           #string module
import MySQLdb
import MySQLdb.cursors
import time
import os
import cgi
import types
import socket
from pychart import *

import cgitb; cgitb.enable()

def printheader():

        print "Content-Type: text/html\n\n"  #reports a web page
        print "<html>\n"
        print "<head><title>Placid</title></head>\n"
        print "<body bgcolor=\"ffffff\">\n"
        print "<table border=0 width=100%><tr><td><b><font size=+2>Placid 2.0</font></b> by Phil Deneault at <a href=\"mailto:deneault@hiddengroup.net?subject=Placid Topic\">deneault@hiddengroup.net</a></td>"
        print "<td><a href=\"placid.py\">[ Home ]</a><nobr><nobr><a href=\"search.py\">[ Search ]</a><nobr><nobr><!--<a href=\"delete.py\">[ Delete ]</a>--></td>"
        print "</tr></table>\n"

def printtail():
	print "</body>\n"
	print "</html>\n"

def dnslookup(ip):
	global nsdict
	if nsdict.has_key(ip):	
		return nsdict[ip]
	else:
		try:
                        sock = socket.gethostbyaddr(ip)
                except:
                        sock = ["None"]
		nsdict[ip] = sock[0]
		return sock[0]

def buildclearurl(c1, clearkey):
	
	tmpstr = ""

	tmpstr = tmpstr + "<a href=\"./summary.py?"
        for k in c1.keys():
		if k != clearkey:
			if k == "groupby" and c1[k] == "ip":
		        	tmpstr = tmpstr + "&" + k + "=none"  
			else:
		        	tmpstr = tmpstr + "&" + k + "=" + c1[k]
        tmpstr = tmpstr + "\">CLEAR</a>"
	return tmpstr

def processplot(form, criteria):

	global options

        query = ""

	select = []
	fromm = []
	where = []
	orderby = ""
	limit = ""
	groupby = ""

	select.append("unix_timestamp(event.timestamp) AS timestamp")
        fromm.append("event")   
        fromm.append("iphdr")
        fromm.append("signature")   
	where.append("event.signature=signature.sig_id")
        where.append("iphdr.sid=event.sid")
        where.append("iphdr.cid=event.cid")
        for i in criteria.items():
                if (i[0] != "sortby") and (i[0] != "timebefore") and (i[0] != "timestop"):
                	if i[0] == "signame":
                                where.append("signature.sig_name=\"" + i[1] + "\"")
			if (i[0] == "ip") and criteria.has_key('ipdst') and (string.strip(criteria['ipdst']) == "distinct") :
				where.append("iphdr.ip_src=inet_aton(\"" + i[1] + "\")")
			elif (i[0] == "ip") and criteria.has_key('ipsrc') and (string.strip(criteria['ipsrc']) == "distinct"):
				where.append("iphdr.ip_dst=inet_aton(\"" + i[1] + "\")")					
        if form.has_key('timestop') and form.has_key('timebefore'):
                where.append("(event.timestamp > \"" + time.strftime("%Y-%m-%d %H:%M:%S", time.gmtime((time.time() - float(form['timebefore'].value)))) + "\")")
                where.append("\"" + time.strftime("%Y-%m-%d %H:%M:%S", time.gmtime((float(form['timebefore'].value)))) + "\" > event.timestamp)")
        elif form.has_key('timebefore'):
                where.append("(event.timestamp > \"" + time.strftime("%Y-%m-%d %H:%M:%S", time.gmtime((time.time() - float(form['timebefore'].value)))) + "\")")
	if form.has_key('sid'):
		where.append("event.sid=\"" + str(form['sid'].value) + "\"")
        orderby = "ORDER BY timestamp ASC"
	if (form.has_key('ip')) and (form.has_key('ipsrc')) and (form['ipsrc']=="distinct"):
		where.append("iphdr.ip_src=" + form['ip']) 
	if (form.has_key('ip')) and (form.has_key('ipdst')) and (form['ipdst']=="distinct"):
		where.append("iphdr.ip_dst=" + form['ip']) 
		
	query = query + "SELECT "
	tmp = len(select)
	for i in range(0, tmp):
		query = query + select[i]
		if i < (tmp-1):
                        query = query + ", "
	query = query + " FROM "
	tmp = len(fromm)
	for i in range(0, tmp):
		query = query + fromm[i]
		if i < (tmp-1):
                        query = query + ", "   
	if len(where) != 0:
		query = query + " WHERE "
		tmp = len(where)
		for i in range(0, tmp):
			query = query + where[i]
			if i < (tmp-1):
				query = query + " and "
	query = query + " " + groupby + " "
	query = query + orderby + " "
	query = query + limit + " "
	query = query + ";"	

	cur=db.cursor()
        cur.execute(query)
        temp = cur.fetchall()

	if len(temp) != 0:
		unit = 86400
		temp1 = []
		for i in temp:	
			temp1.append(i[0])
		if max(temp1) - min(temp1) <= 60:
			unit = 1
		elif max(temp1) - min(temp1) <= 3600:
			unit = 60
		elif max(temp1) - min(temp1) <= 86400:
			unit = 3600
		elif max(temp1) - min(temp1) <= 604800:
			unit = 86400	

		minval = int(min(temp1))
		data = []
		currentindex = 0
		test = 0
		for i in temp1:
			t = minval + currentindex*unit
			if int(i) <= t:
				test = test + 1
			else:	

				if unit == 1:
					data.append([time.strftime("%H:%M:%S",time.localtime(t)), test])
				elif unit == 60:
					data.append([time.strftime("%H:%M",time.localtime(t)), test])
				elif unit == 3600:	
					data.append([time.strftime("%H:%M",time.localtime(t)), test])
				elif unit == 86400:
					data.append([time.strftime("%m-%d",time.localtime(t)), test])
				currentindex = currentindex + 1
				test = 0

		try:	
			theme.get_options()
			theme.scale_factor = 2
			theme.default_font_size = 6	
			theme.reinitialize()
			os.remove("images/g.png")
			can = canvas.init("images/g.png")
			ar = area.T(size = (400, 120), x_coord = category_coord.T(data, 0), y_range = (0, None), x_axis = axis.X(label="Time"), y_axis = axis.Y(label="Count"))
			ar.add_plot(bar_plot.T(data = data, label = ""))
			ar.draw(can)
		except:
			pass
		print "<img src=\"images/g.png\">"
	else:
                print "Nothing to plot"
	printtail()
	

def printcriteria(form1):

	global options

        c = {}
        tmp = form1.keys()
        for i in tmp:
		if isinstance(form1[i], types.ListType):
	                c[i] = str(form1[i][len(i)-1].value)
		else:
			c[i] = str(form1[i].value)
	print "<table border=0><tr><td>"
	print "<table border=1>"
	print "<tr bgcolor=#ffbbbb><td colspan=5>META</td></tr>"
	if c.has_key('timebefore'):
		clear = "timebefore"
		print "<tr><td>Time From</td><td>" + time.ctime(time.time() - float(string.strip(c['timebefore']))) + "</td><td>" + buildclearurl(c, clear) + "</td></tr>"
	if c.has_key('timestop'):
		clear = "timestop"
		print "<tr><td>Time To</td><td>" + time.ctime(time.time() - float(string.strip(c['timestop']))) + "</td><td>" + buildclearurl(c, clear) + "</td></tr>"
	else:
		print "<tr><td>Time To</td><td>NOW</td></tr>"
	if c.has_key('signame'):
		clear = "signame"
		print "<tr><td>Sig name</td><td>" + c['signame'] + "</td><td>" + buildclearurl(c, clear) + "</td></tr>"
	if c.has_key('distinct'):
		clear = "distinct"
                print "<tr><td>Distinct</td><td>" + c['distinct'] + "</td><td>" + buildclearurl(c, clear) + "</td></tr>"
	if c.has_key('skipgroups'):
		clear = "skipgroups"
		tmp1 = buildclearurl(c, clear)
                print "<tr><td>Skipped Rows</td><td>" + c['skipgroups'] + "</td><td> N/A </td>",
		print "<td><form method=post action=\"summary.py\">",
		for i in form1.keys():
			if i != 'skipgroups':
				print "<input type=hidden name=\"" + i + "\" value=\"" + c[i] + "\">",
		print "<input type=text name=\"skipgroups\" value=\"" + c['skipgroups'] + "\">",
		print "<input value=\"Change Value\" type=submit></form>",
		print "</td>",
		print "</tr>",

	else:
		clear = "skipgroups"
		tmp1 = buildclearurl(c, clear)
                print "<tr><td>Skipped Rows</td><td>" + "0" + "</td><td> N/A </td>",
		print "<td><form method=post action=\"summary.py\">",
		for i in form1.keys():
			if i != 'skipgroups':
				print "<input type=hidden name=\"" + i + "\" value=\"" + c[i] + "\">",
		print "<input type=text name=\"skipgroups\" value=\"" + "0" + "\">",
		print "<input value=\"Change Value\" type=submit></form>",
		print "</td>",
		print "</tr>",
	if c.has_key('numgroups'):
		clear = "numgroups"
		tmp1 = buildclearurl(c, clear)
                print "<tr><td>Num Rows</td><td>" + c['numgroups'] + "</td><td> N/A </td>",
		print "<td><form method=post action=\"summary.py\">",
		for i in form1.keys():
			if i != 'numgroups':
				print "<input type=hidden name=\"" + i + "\" value=\"" + c[i] + "\">",
		print "<input type=text name=\"numgroups\" value=\"" + c['numgroups'] + "\">",
		print "<input value=\"Change Value\" type=submit></form>",
		print "</td>",
		print "</tr>",

	else:
		clear = "numgroups"
		tmp1 = buildclearurl(c, clear)
                print "<tr><td>Num Rows</td><td>" + options['entrieslimit'] + "</td><td> N/A </td>",
		print "<td><form method=post action=\"summary.py\">",
		for i in form1.keys():
			if i != 'numgroups':
				print "<input type=hidden name=\"" + i + "\" value=\"" + options['entrieslimit'] + "\">",
		print "<input type=text name=\"numgroups\" value=\"" + options['entrieslimit'] + "\">",
		print "<input value=\"Change Value\" type=submit></form>",
		print "</td>",
		print "</tr>",

	if c.has_key('senhost'):
                clear = "senhost"
                print "<tr><td>Sensor</td><td>" + c['senhost'] + "</td><td>" + buildclearurl(c, clear) + "</td></tr>"
	if c.has_key('sid'):
                clear = "sid"
                print "<tr><td>Sensor ID</td><td>" + c['sid'] + "</td><td>" + buildclearurl(c, clear) + "</td></tr>"
	print "<tr bgcolor=#bbffbb><td colspan=5>IP</td></tr>"
	if c.has_key('ipsrc'):
		clear = "ipsrc"
                print "<tr><td>IP SRC</td><td>" + c['ipsrc'] + "</td><td>" + buildclearurl(c, clear) + "</td></tr>"
	if c.has_key('ipdst'):
		clear = "ipdst"
                print "<tr><td>IP DST</td><td>" + c['ipdst'] + "</td><td>" + buildclearurl(c, clear) + "</td></tr>"
	if c.has_key('distinct'):
                clear = "distinct"
                print "<tr><td>Distinct</td><td>" + c['distinct'] + "</td><td>" + buildclearurl(c, clear) + "</td></tr>"
	if c.has_key('ip'):
                clear = "ip"
                print "<tr><td>IP</td><td>" + c['ip'] + "</td><td>" + buildclearurl(c, clear) + "</td></tr>"
	print "<tr bgcolor=#bbbbff><td colspan=5>Layer 4</td></tr>"
	if c.has_key('layer4'):
		clear = "layer4"
                print "<tr><td>Layer4 Proto</td><td>" + c['layer4'] + "</td><td>" + buildclearurl(c, clear) + "</td></tr>"
	print "<tr bgcolor=#bbffff><td colspan=5>Payload</td></tr></table>"
	print "</td><td>"
	print "<form method=\"post\" action=\"summary.py\">"
	for i in form1.keys():
		if i != "inputtype" and i != "ip":
	        	        print "<input type=hidden name=\"" + i + "\" value=\"" + form1[i].value + "\">",
	print "<input type=hidden name=\"inputtype\" value=\"plot\"><input value=\"Plot\" type=submit></form>"


	print "</td></tr></table>"
	

def buildquery(form, criteria):

	global options

        query = ""

#VERSION 2

	select = []
	fromm = []
	where = []
	orderby = ""
	limit = ""
	groupby = ""

	if form['groupby'].value == "signatures":
		groupby = "GROUP BY sig"
		select.append("signature.sig_name AS name")
		select.append("count(*) AS total")
		select.append("count(distinct iphdr.ip_src) AS src")
		select.append("count(distinct iphdr.ip_dst) AS dst")
		select.append("count(distinct sensor.hostname) AS sensor")
		select.append("max(event.timestamp) AS timestamp")
                select.append("event.signature AS sig")
		fromm.append("event")
		fromm.append("iphdr")
		fromm.append("signature")
		fromm.append("sensor")
		where.append("event.sid=sensor.sid")
		where.append("event.signature=signature.sig_id")
		where.append("iphdr.sid=event.sid")
		where.append("iphdr.cid=event.cid")
	        for i in criteria.items():
	                if (i[0] != "sortby") and (i[0] != "timebefore") and (i[0] != "timestop"):
				if i[0] == "signame":
                	        	where.append("signature.sig_name=\"" + string.strip(i[1]) + "\"")
		if form.has_key('timestop') and form.has_key('timebefore'):
			where.append("(event.timestamp > \"" + time.strftime("%Y-%m-%d %H:%M:%S", time.gmtime((time.time() - float(form['timebefore'].value)))) + "\")")
			where.append("\"" + time.strftime("%Y-%m-%d %H:%M:%S", time.gmtime((float(form['timebefore'].value)))) + "\" > event.timestamp)")
		elif form.has_key('timebefore'):
			where.append("(event.timestamp > \"" + time.strftime("%Y-%m-%d %H:%M:%S", time.gmtime((time.time() - float(form['timebefore'].value)))) + "\")")
		if form.has_key('numgroups') and form.has_key('skipgroups'):
			limit = "LIMIT " + str(form['skipgroups'].value) + ", " + str(form['numgroups'].value)
		elif form.has_key('numgroups'):
			limit = "LIMIT 0, " + str(form['numgroups'].value)
		elif form.has_key('skipgroups'):
			limit = "LIMIT " + str(form['skipgroups'].value) + ", " + options['entrieslimit']
		else:
			limit = "LIMIT 0, " + options['entrieslimit'] 
		if form.has_key('sortby'):
			orderby = "ORDER BY " + str(form['sortby'].value)
			if form.has_key('sortdir') and form['sortdir'].value == "asc":
				orderby = orderby + " ASC"
			else:
				orderby = orderby + " DESC"
	elif form['groupby'].value == "sensor":
                groupby = "GROUP BY sid"
                select.append("sensor.sid AS sid")
                select.append("sensor.hostname AS senhost")
                select.append("sensor.interface AS seninter")
		select.append("count(*) AS events")
                select.append("count(distinct iphdr.ip_src) AS src")
                select.append("count(distinct iphdr.ip_dst) AS dst")
                fromm.append("event")
                fromm.append("iphdr")
		fromm.append("sensor")
                where.append("iphdr.sid=event.sid")
                where.append("iphdr.cid=event.cid")
		where.append("sensor.sid=event.sid")
                if form.has_key('signame'):
	        	where.append("signature.sig_name=\"" + form['signame'].value + "\"")
			where.append("event.signature=signature.sig_id")
			fromm.append("signature")
                if form.has_key('timestop') and form.has_key('timebefore'):
                        where.append("(event.timestamp > \"" + time.strftime("%Y-%m-%d %H:%M:%S", time.gmtime((time.time() - float(form['timebefore'].value)))) + "\")")
                        where.append("\"" + time.strftime("%Y-%m-%d %H:%M:%S", time.gmtime((float(form['timebefore'].value)))) + "\" > event.timestamp)")
                elif form.has_key('timebefore'):   
                        where.append("(event.timestamp > \"" + time.strftime("%Y-%m-%d %H:%M:%S", time.gmtime((time.time() - float(form['timebefore'].value)))) + "\")")
		if form.has_key('numgroups') and form.has_key('skipgroups'):
			limit = "LIMIT " + str(form['skipgroups'].value) + ", " + str(form['numgroups'].value)
		elif form.has_key('numgroups'):
			limit = "LIMIT 0, " + str(form['numgroups'].value)
		elif form.has_key('skipgroups'):
			limit = "LIMIT " + str(form['skipgroups'].value) + ", " + options['entrieslimit']
		else:
			limit = "LIMIT 0, " + options['entrieslimit'] 
                if form.has_key('sortby'):   
                        orderby = "ORDER BY " + str(form['sortby'].value)
                        if form.has_key('sortdir') and form['sortdir'].value == "asc":
                                orderby = orderby + " ASC"
                        else:
                                orderby = orderby + " DESC"
	elif form['groupby'].value == "ip":
		if (form.has_key('ipsrc')) and (form['ipsrc'].value == "distinct"):
			select.append("inet_ntoa(iphdr.ip_dst) AS dst")
	                groupby = "GROUP BY dst"
		elif (form.has_key('ipdst')) and (form['ipdst'].value == "distinct"):
			select.append("inet_ntoa(iphdr.ip_src) AS src")
			groupby = "GROUP BY src"
		select.append("signature.sig_name AS signame")
		select.append("count(*) AS total")
	        select.append("iphdr.ip_proto AS proto")
                fromm.append("event")
                fromm.append("iphdr")
		fromm.append("signature")
                where.append("iphdr.sid=event.sid")
                where.append("iphdr.cid=event.cid")
		where.append("signature.sig_id=event.signature")
                for i in criteria.items():
                        if (i[0] != "sortby") and (i[0] != "timebefore") and (i[0] != "timestop"):
                                if i[0] == "signame":
                                        where.append("signature.sig_name=\"" + i[1] + "\"")
                                if i[0] == "ip":
					if (form.has_key('ipsrc')) and (form['ipsrc'].value == "distinct"):
	                                        where.append("iphdr.ip_src=inet_aton(\"" + i[1] + "\")")
					if (form.has_key('ipdst')) and (form['ipdst'].value == "distinct"):
						where.append("iphdr.ip_dst=inet_aton(\"" + i[1] + "\")")
                if form.has_key('timestop') and form.has_key('timebefore'):
                        where.append("(event.timestamp > \"" + time.strftime("%Y-%m-%d %H:%M:%S", time.gmtime((time.time() - float(form['timebefore'].value)))) + "\")")
                        where.append("\"" + time.strftime("%Y-%m-%d %H:%M:%S", time.gmtime((float(form['timebefore'].value)))) + "\" > event.timestamp)")
                elif form.has_key('timebefore'):   
                        where.append("(event.timestamp > \"" + time.strftime("%Y-%m-%d %H:%M:%S", time.gmtime((time.time() - float(form['timebefore'].value)))) + "\")")
		if form.has_key('numgroups') and form.has_key('skipgroups'):
			limit = "LIMIT " + str(form['skipgroups'].value) + ", " + str(form['numgroups'].value)
		elif form.has_key('numgroups'):
			limit = "LIMIT 0, " + str(form['numgroups'].value)
		elif form.has_key('skipgroups'):
			limit = "LIMIT " + str(form['skipgroups'].value) + ", " + options['entrieslimit']
		else:
			limit = "LIMIT 0, " + options['entrieslimit'] 
                if form.has_key('sortby'):   
                        orderby = "ORDER BY " + str(form['sortby'].value)
                        if form.has_key('sortdir') and form['sortdir'].value == "asc":
                                orderby = orderby + " ASC"
                        else:
                                orderby = orderby + " DESC"
	elif ((form['groupby'].value == "none") or (not form.has_key(groupby))):
                groupby = ""
                select.append("event.sid AS sid")
                select.append("event.cid AS cid")
		select.append("event.timestamp AS timestamp")
		select.append("signature.sig_name AS signame")
		select.append("inet_ntoa(iphdr.ip_src) AS src")
		select.append("inet_ntoa(iphdr.ip_dst) AS dst")
		select.append("iphdr.ip_proto AS proto")
		select.append("iphdr.ip_len AS length")
                fromm.append("event")   
                fromm.append("iphdr")
                fromm.append("signature")   
                where.append("event.signature=signature.sig_id")
                where.append("iphdr.sid=event.sid")
                where.append("iphdr.cid=event.cid")
                for i in criteria.items():
                        if (i[0] != "sortby") and (i[0] != "timebefore") and (i[0] != "timestop"):
                                if i[0] == "signame":
                                        where.append("signature.sig_name=\"" + i[1] + "\"")
				if (i[0] == "ip") and criteria.has_key('ipdst') and (string.strip(criteria['ipdst']) == "distinct") :
					where.append("iphdr.ip_dst=inet_aton(\"" + i[1] + "\")")					
				elif (i[0] == "ip") and criteria.has_key('ipsrc') and (string.strip(criteria['ipsrc']) == "distinct"):
					where.append("iphdr.ip_src=inet_aton(\"" + i[1] + "\")")					
                if form.has_key('timestop') and form.has_key('timebefore'):
                        where.append("(event.timestamp > \"" + time.strftime("%Y-%m-%d %H:%M:%S", time.gmtime((time.time() - float(form['timebefore'].value)))) + "\")")
                        where.append("\"" + time.strftime("%Y-%m-%d %H:%M:%S", time.gmtime((float(form['timebefore'].value)))) + "\" > event.timestamp)")
                elif form.has_key('timebefore'):
                        where.append("(event.timestamp > \"" + time.strftime("%Y-%m-%d %H:%M:%S", time.gmtime((time.time() - float(form['timebefore'].value)))) + "\")")
		if form.has_key('sid'):
			where.append("event.sid=\"" + str(form['sid'].value) + "\"")
		if form.has_key('numgroups') and form.has_key('skipgroups'):
			limit = "LIMIT " + str(form['skipgroups'].value) + ", " + str(form['numgroups'].value)
		elif form.has_key('numgroups'):
			limit = "LIMIT 0, " + str(form['numgroups'].value)
		elif form.has_key('skipgroups'):
			limit = "LIMIT " + str(form['skipgroups'].value) + ", " + options['entrieslimit']
		else:
			limit = "LIMIT 0, " + options['entrieslimit'] 
                if form.has_key('sortby'):
                        orderby = "ORDER BY " + str(form['sortby'].value)
                        if form.has_key('sortdir') and form['sortdir'].value == "asc":
                                orderby = orderby + " ASC"
                        else:
                                orderby = orderby + " DESC"
		if (form.has_key('ip')) and (form.has_key('ipsrc')) and (form['ipsrc']=="distinct"):
			where.append("iphdr.ip_src=" + form['ip']) 
		if (form.has_key('ip')) and (form.has_key('ipdst')) and (form['ipdst']=="distinct"):
			where.append("iphdr.ip_dst=" + form['ip']) 
		


	query = query + "SELECT STRAIGHT_JOIN "
	tmp = len(select)
	for i in range(0, tmp):
		query = query + select[i]
		if i < (tmp-1):
                        query = query + ", "
	query = query + " FROM "
	tmp = len(fromm)
	for i in range(0, tmp):
		query = query + fromm[i]
		if i < (tmp-1):
                        query = query + ", "   
	query = query + " WHERE "
	tmp = len(where)
	for i in range(0, tmp):
		query = query + where[i]
		if i < (tmp-1):
			query = query + " and "
	query = query + " " + groupby + " "
	query = query + orderby + " "
	query = query + limit + " "
	query = query + ";"	

	print query

#---------------VERSION 1--------------------------------------------------------------------------------------------------------------
#        if form['groupby']:
#                if form['groupby'].value == "signatures":
#                        query = "SELECT STRAIGHT_JOIN signature.sig_name AS sig, count(*) AS total, count(distinct iphdr.ip_src) AS src, 
#                                 count(distinct iphdr.ip_dst) AS dst, count(distinct sensor.hostname) AS sensor, max(event.timestamp) 
#                                 AS timestamp FROM event, iphdr, signature, sensor WHERE "
#			try:
#	                        if form['timebefore']:
#        	                        query = query + "(unix_timestamp(event.timestamp) > " + str(time.time() - float(form['timebefore'].value)) + ") and "
#			except:
#				pass
#                        query = query + "event.sid=sensor.sid and event.signature=signature.sig_id and iphdr.sid=event.sid and iphdr.cid=event.cid "
#                        query = query + "GROUP BY sig "
#                        try:
#                                if form['sortby']:
#                                        if form['sortby'].value == "recent":
#                                                query = query + "ORDER BY timestamp DESC "
#                                        elif form['sortby'].value == "most":
#                                                query = query + "ORDER BY total DESC "
#					elif form['sortby'].value == "Alphebetically":
#                                                query = query + "ORDER BY sig DESC "
#			except:
#				pass
#			try:
#				if form['numgroups']:
#					query= query + "LIMIT " + str(form['numgroups'].value) + " "
#                       except:
#                                pass
#
#        query = query + ";"
#---------------------------------------------------------------------------------------------------------------------------------------

        return query

def processsearch(form1):

	global options

	query = ""	

        select = []
        fromm = []
        where = []
        orderby = ""
	limit = "LIMIT 0, 1000"
    
	select.append("event.sid AS sid")
        select.append("event.cid AS cid")
        select.append("event.timestamp AS timestamp")
        select.append("signature.sig_name AS signame")
        select.append("inet_ntoa(iphdr.ip_src) AS src")
        select.append("inet_ntoa(iphdr.ip_dst) AS dst")
        select.append("iphdr.ip_proto AS proto")
	fromm.append("event")
        fromm.append("iphdr")
        fromm.append("signature")
        fromm.append("sensor")
	if form1.has_key("proto") and (form1["proto"].value == "1"):
		fromm.append("icmphdr")
	        where.append("icmphdr.sid=event.sid")
	        where.append("icmphdr.cid=event.cid")
		where.append("iphdr.ip_proto=1")
		if form1.has_key("icmpcode"):
			where.append("icmphdr.icmp_type=" + form1["icmpcode"].value)
	elif form1.has_key("proto") and (form1["proto"].value == "6"):
	        fromm.append("tcphdr")
		where.append("tcphdr.sid=event.sid")
	        where.append("tcphdr.cid=event.cid")
		where.append("iphdr.ip_proto=6")
		if form1.has_key("srcport"):
			where.append("tcphdr.tcp_sport=" + form1["srcport"].value)
		if form1.has_key("dstport"):
			where.append("tcphdr.tcp_dport=" + form1["dstport"].value)
	elif form1.has_key("proto") and (form1["proto"].value == "17"):
	        fromm.append("udphdr")
	        where.append("udphdr.sid=event.sid")
	        where.append("udphdr.cid=event.cid")
		where.append("iphdr.ip_proto=17")
		if form1.has_key("srcport"):
			where.append("tcphdr.tcp_sport=" + form1["srcport"].value)
		if form1.has_key("dstport"):
			where.append("tcphdr.tcp_dport=" + form1["dstport"].value)
	if form1.has_key("datakey"):
		fromm.append("data")
		where.append("data.sid=event.sid")
	        where.append("data.cid=event.cid")
		tmp = ""
		for i in list(form1["datakey"].value):
			tmp = tmp + str(hex(ord(i)))[2:]
		where.append("data.data_payload like \"%" + tmp + "%\"")
	where.append("event.sid=sensor.sid")
        where.append("event.signature=signature.sig_id")
        where.append("iphdr.sid=event.sid")
        where.append("iphdr.cid=event.cid")
	if form1.has_key("sid"):
		where.append("sensor.sid=" + form1['sid'].value)
	if form1.has_key("signature"):
		where.append("signature.sig_name LIKE \'%" + form1["signature"].value + "%\'")
	if form1.has_key("sigid"):
		where.append("signature.sig_sid=" + form1["sigid"].value)
	if form1.has_key("srcip"):
		where.append("iphdr.ip_src=inet_aton(\"" + form1["srcip"].value + "\")")
	elif (form1.has_key("srcstartip") and form1.has_key("srcendip")):
		where.append("iphdr.ip_src >= inet_aton(\"" + form1["srcstartip"].value + "\") and iphdr.ip_src <= inet_aton(\"" + form1["srcendip"].value + "\")")
	if form1.has_key("dstip"):
		where.append("iphdr.ip_dst=inet_aton(\"" + form1["dstip"].value + "\")")
	elif (form1.has_key("dststartip") and form1.has_key("dstendip")):
		where.append("iphdr.ip_dst >= inet_aton(\"" + form1["dststartip"].value + "\") and iphdr.ip_dst <= inet_aton(\"" + form1["dstendip"].value + "\")")
	if form1.has_key("lentest") and form1.has_key("len"):
		where.append("iphdr.ip_len" + form1["lentest"].value  + form1["len"].value)
	if form1.has_key("orderby"):
		if form1["orderby"].value == "timestamp ascending":
			orderby = " ORDER BY timestamp ASC"
		if form1["orderby"].value == "timestamp decending":
			orderby = " ORDER BY timestamp DESC"
	if form1.has_key("syear") and form1.has_key("smonth") and form1.has_key("sday") and form1.has_key("shour") and form1.has_key("sminute"):
		tmp = form1["syear"].value + " " + form1["smonth"].value + " " +  form1["sday"].value + " " +  form1["shour"].value + " " +  form1["sminute"].value
		where.append("event.timestamp > " + str(time.mktime(time.strptime(tmp, '%Y %m %d %H %M'))))
	if form1.has_key("eyear") and form1.has_key("emonth") and form1.has_key("eday") and form1.has_key("ehour") and form1.has_key("eminute"):
                tmp = form1["eyear"].value + " " + form1["emonth"].value + " " +  form1["eday"].value + " " +  form1["ehour"].value + " " +  form1["eminute"].value
                where.append("event.timestamp > " + str(time.mktime(time.strptime(tmp, '%Y %m %d %H %M'))))

	query = query + "SELECT "
        tmp = len(select)   
        for i in range(0, tmp):
                query = query + select[i]
                if i < (tmp-1):
                        query = query + ", "
        query = query + " FROM "
        tmp = len(fromm)
        for i in range(0, tmp):
                query = query + fromm[i]
                if i < (tmp-1):
                        query = query + ", "
        query = query + " WHERE "
        tmp = len(where)
        for i in range(0, tmp):
                query = query + where[i]
                if i < (tmp-1):
                        query = query + " and "
        query = query + orderby + " "
	query = query + limit + " "
        query = query + ";"

	cur=db.cursor()
        cur.execute(query)
        temp = cur.fetchall()

	print "<table width=100% border=1>"
        print "<tr bgcolor=#dddddd><td>SID</td><td>CID</td><td>Timestamp</td><td>Signature</td><td>IP Src</td><td>IP Dst</td><td>Proto</td></tr>"
        for i in temp:
        	print "<tr>",
                for j in range(0,7):
                	if j == 0:
                        	print "<td><a href=\"./event.py?sid=" + str(i[0]) + "&cid=" + str(i[1]) + "\">",
                                print str(i[j]) + "</a></td>",
                        elif j == 1:
                                print "<td><a href=\"./event.py?sid=" + str(i[0]) + "&cid=" + str(i[1]) + "\">",
                                print str(i[j]) + "</a></td>",
                        elif j == 2:
                                print "<td>" + str(i[j]) + "</td>"
                        elif j == 3:
                                print "<td><a href=\"./summary.py?",
#                                for k in criteria.keys():
#        	                        print "&" + k + "=" + criteria[k],
                                print "&groupby=signatures\">",
                                print str(i[j]) + "</a></td>",
                        elif j == 4:
                                print "<td><a href=\"./summary.py?",
#                                for k in criteria.keys():  
#        	                        print "&" + k + "=" + criteria[k],
                                print "&ipsrc=distinct&ip=" + str(i[j]) + "&groupby=ip\">",
                                print str(i[j]) + "</a></td>",
                        elif j == 5:
                                print "<td><a href=\"./summary.py?",
#                               	for k in criteria.keys():
#        	                        print "&" + k + "=" + criteria[k],
                                print "&ipdst=distinct&ip=" + str(i[j]) + "&groupby=ip\">",
                                print str(i[j]) + "</a></td>",
                        elif j == 6:
                                print "<td>" + str(i[j]) + "</td>"
        	print "</tr>"
	print "</table>"
	printtail()


def main():

	printheader()

	global options
        options = {}

	global nsdict
	nsdict = {}

        fin = open("./placid.cfg")
        line = fin.readline()
        while line:
                if line[0] != "#":
                        tmp = string.split(line, "=")
                        options[tmp[0]] = string.strip(tmp[1])
                line = fin.readline()
        fin.close()

	global db
##changed
	MySQLdb.threadsafety=1
	db = MySQLdb.connect(host=options['dbhost'],db=options['db'],passwd=options['passwd'],user=options['user'])

	form = cgi.FieldStorage()

	if form.has_key("inputtype") and form["inputtype"].value == 'plot':
		tmp = form.keys()
                criteria = {}
                for i in tmp:
                        if (i != "numgroups") and (i != "groupby") and (i != "sortby"):
                                if isinstance(form[i], types.ListType):
                                        criteria[i] = str(form[i][len(i)-1].value)
                                else:
                                        criteria[i] = str(form[i].value)
		processplot(form, criteria)
	elif form.has_key("inputtype"):
		processsearch(form)
	else:

		tmp = form.keys()
		criteria = {}
		for i in tmp:
			if (i != "numgroups") and (i != "groupby") and (i != "sortby"):
				if isinstance(form[i], types.ListType):
					criteria[i] = str(form[i][len(i)-1].value)
				else:
					criteria[i] = str(form[i].value)
		printcriteria(form)

		query = buildquery(form, criteria)
		
		cur=db.cursor()
	        cur.execute(query)
	        temp = cur.fetchall()
		if form['groupby'].value == "signatures":	
			print "<table width=100% border=1>"
			print "<tr><td align=right colspan=6 border=0>"
			print "<form method=post action=\"summary.py\">",
			for z in form.keys():
				if z != 'skipgroups':
					print "<input type=hidden name=\"" + z + "\" value=\"" + form[z].value + "\">",
			if criteria.has_key('skipgroups') and form.has_key('numgroups'):
				print "<input type=hidden name=\"skipgroups\" value=\"" + str(int(criteria['skipgroups']) + int(form['numgroups'].value)) + "\">",
			elif criteria.has_key('skipgroups'):
				print "<input type=hidden name=\"skipgroups\" value=\"" + str(int(criteria['skipgroups']) + int(options['entrieslimit'])) + "\">",
			else:
				print "<input type=hidden name=\"skipgroups\" value=\"" + str(0) + "\">",
			print "<input value=\"Next\" type=submit></form></td></tr>",
			print "<tr bgcolor=#dddddd><td>Signature</td><td>Total Events</td><td>IP Srcs</td><td>IP Dsts</td><td>Sensor</td><td>Latest Timestamp</td></tr>"
		        for i in temp:
				print "<tr>",
				for j in range(0,6):
					if j == 0:
						print "<td><a href=\"./summary.py?", 
						for k in criteria.keys():
							print "&" + k + "=" + criteria[k],
                	                        print "&signame=" + i[0]					
						print "&groupby=none\">",
						print str(i[j]) + "</a></td>",
					elif j == 1:			
						print "<td><a href=\"./summary.py?", 
						for k in criteria.keys():
                                	                print "&" + k + "=" + criteria[k],
						if form.has_key('signame') == 0:
							print "&signame=" + i[0]
						print "&groupby=none\">",					
 						print str(i[j]) + "</a></td>",
					elif j == 2:				
						print "<td><a href=\"./summary.py?", 
						for k in criteria.keys():
							if k != "ip" and k != "ipsrc" and k != "ipdst":
	                        	                        print "&" + k + "=" + criteria[k],
						if form.has_key('signame') == 0:
							print "&signame=" + i[0] 
						print "&ipdst=distinct&groupby=ip\">",					
						print str(i[j]) + "</a></td>",
					elif j == 3:				
						print "<td><a href=\"./summary.py?", 
						for k in criteria.keys():
							if k != "ip" and k != "ipdst" and k != "ipsrc":
	                                        	        print "&" + k + "=" + criteria[k],
						if form.has_key('signame') == 0:
							print "&signame=" + i[0] 
						print "&ipsrc=distinct&groupby=ip\">",					
						print str(i[j]) + "</a></td>",
					elif j == 4:
						print "<td><a href=\"./summary.py?",
                                        	for k in criteria.keys():
                                                	print "&" + k + "=" + criteria[k],
						if form.has_key('signame') == 0:
							print "&signame=" + i[0] 
        	                                print "&groupby=sensor\">",
	                                        print str(i[j]) + "</a></td>",
					elif j == 5:				
						print "<td>" + str(i[j]) + "</td>",
				print "</tr>"
			print "<tr><td align=right colspan=6 border=0>"
			print "<form method=post action=\"summary.py\">",
			for z in form.keys():
				if z != 'skipgroups':
					print "<input type=hidden name=\"" + z + "\" value=\"" + form[z].value + "\">",
			if criteria.has_key('skipgroups') and form.has_key('numgroups'):
				print "<input type=hidden name=\"skipgroups\" value=\"" + str(int(criteria['skipgroups']) + int(form['numgroups'].value)) + "\">",
			elif criteria.has_key('skipgroups'):
				print "<input type=hidden name=\"skipgroups\" value=\"" + str(int(criteria['skipgroups']) + int(options['entrieslimit'])) + "\">",
			else:
				print "<input type=hidden name=\"skipgroups\" value=\"" + str(0) + "\">",
			print "<input value=\"Next\" type=submit></form></td></tr>",

			print "</table>"
		elif ((form['groupby'].value == "none") or (not form.has_key('groupby'))):
			print "<table width=100% border=1>"
			print "<tr><td align=right colspan=8 border=0>"
			print "<form method=post action=\"summary.py\">",
			for z in form.keys():
				if z != 'skipgroups' and z != 'ip':
					        print "<input type=hidden name=\"" + z + "\" value=\"" + form[z].value + "\">",
			if criteria.has_key('skipgroups') and form.has_key('numgroups'):
				print "<input type=hidden name=\"skipgroups\" value=\"" + str(int(criteria['skipgroups']) + int(form['numgroups'].value)) + "\">",
			elif criteria.has_key('skipgroups') and not criteria.has_key('numgroups'):
				print "<input type=hidden name=\"skipgroups\" value=\"" + str(int(criteria['skipgroups']) + int(options['entrieslimit'])) + "\">",
			else:
				print "<input type=hidden name=\"skipgroups\" value=\"" + str(0) + "\">",
			print "<input value=\"Next\" type=submit></form></td></tr>",
	                print "<tr bgcolor=#dddddd><td>SID</td><td>CID</td><td>Timestamp</td><td>Signature</td><td>IP Src</td><td>IP Dst</td><td>Proto</td><td>Length</td></tr>"	
	                for i in temp:
	                	print "<tr>",
	                        for j in range(0,8):
					if j == 0:
						print "<td><a href=\"./event.py?sid=" + str(i[0]) + "&cid=" + str(i[1]) + "\">",
						print str(i[j]) + "</a></td>",
					elif j == 1:
						print "<td><a href=\"./event.py?sid=" + str(i[0]) + "&cid=" + str(i[1]) + "\">",
						print str(i[j]) + "</a></td>",
					elif j == 2:
                        	                print "<td>" + str(i[j]) + "</td>"
					elif j == 3:
						print "<td><a href=\"./summary.py?",
                	                        for k in criteria.keys():
                        	                        print "&" + k + "=" + criteria[k],
                                	        print "&groupby=signatures\">",
	                                        print str(i[j]) + "</a></td>",
					elif j == 4:
	                                        print "<td><a href=\"./summary.py?",
	                                        for k in criteria.keys():
							if k != "ip" and k != "ipdst" and k != "ipsrc":
		                                                print "&" + k + "=" + criteria[k],
	                                        print "&ipsrc=distinct&ip=" + str(i[j]) + "&groupby=ip\">", 
  	                                        print str(i[j]) + "</a>",
                                                if options.has_key("resolvedns") and options["resolvedns"]=="yes":
                                                        print dnslookup(i[j])
						print "</td>",
					elif j == 5:
	                                        print "<td><a href=\"./summary.py?",
	                                        for k in criteria.keys():	
							if k != "ip" and k != "ipdst" and k != "ipsrc":
                                                                print "&" + k + "=" + criteria[k],
	                                        print "&ipdst=distinct&ip=" + str(i[j]) + "&groupby=ip\">", 
	                                        print str(i[j]) + "</a>",
                                                if options.has_key("resolvedns") and options["resolvedns"]=="yes":
                                                        print dnslookup(i[j])
						print "</td>",
					elif j == 6:
	                                        print "<td>" + str(i[j]) + "</td>"
					elif j == 7:
	                                        print "<td>" + str(i[j]) + "</td>"
	                        print "</tr>"
			print "<tr><td align=right colspan=8 border=0>"
			print "<form method=post action=\"summary.py\">",
			for z in form.keys():
				if z != 'skipgroups' and z != 'ip':
					        print "<input type=hidden name=\"" + z + "\" value=\"" + form[z].value + "\">",
			if criteria.has_key('skipgroups') and form.has_key('numgroups'):
				print "<input type=hidden name=\"skipgroups\" value=\"" + str(int(criteria['skipgroups']) + int(form['numgroups'].value)) + "\">",
			elif criteria.has_key('skipgroups') and not criteria.has_key('numgroups'):
				print "<input type=hidden name=\"skipgroups\" value=\"" + str(int(criteria['skipgroups']) + int(options['entrieslimit'])) + "\">",
			else:
				print "<input type=hidden name=\"skipgroups\" value=\"" + str(0) + "\">",
			print "<input value=\"Next\" type=submit></form></td></tr>",
	                print "</table>"	
		elif form['groupby'].value == "sensor":
			print "<table width=100% border=1>"
			print "<tr><td align=right colspan=6 border=0>"
			print "<form method=post action=\"summary.py\">",
			for z in form.keys():
				if z != 'skipgroups':
					print "<input type=hidden name=\"" + z + "\" value=\"" + form[z].value + "\">",
			if criteria.has_key('skipgroups') and form.has_key('numgroups'):
				print "<input type=hidden name=\"skipgroups\" value=\"" + str(int(criteria['skipgroups']) + int(form['numgroups'].value)) + "\">",
			elif criteria.has_key('skipgroups'):
				print "<input type=hidden name=\"skipgroups\" value=\"" + str(int(criteria['skipgroups']) + int(options['entrieslimit'])) + "\">",
			else:
				print "<input type=hidden name=\"skipgroups\" value=\"" + str(0) + "\">",
			print "<input value=\"Next\" type=submit></form></td></tr>",
	                print "<tr bgcolor=#dddddd><td>Sensor ID</td><td>Sensor hostname</td><td>Sensor Interface</td><td>Total Events</td><td>Unique Src</td><td>Unique Dst</td></tr>"
	                for i in temp:
	                        print "<tr>",
				for j in range(0,6):
	                                if j == 0:
						print "<td><a href=\"./summary.py?",
	                                        for k in criteria.keys():
	                                                print "&" + k + "=" + criteria[k],
	                                        print "&groupby=signatures&sid=" + str(i[j]) + "\">",
	                                        print str(i[j]) + "</a></td>",
	                                elif j == 1:
						print "<td><a href=\"./summary.py?",	
	                                        for k in criteria.keys():
	                                                print "&" + k + "=" + criteria[k],
	                                        print "&groupby=signatures&sid=" + str(i[0]) + "\">",
	                                        print str(i[j]) + "</a></td>",
	                                elif j == 2:
	                                        print "<td>" + str(i[j]) + "</td>"
	                                elif j == 3:
	                                        print "<td><a href=\"./summary.py?",
	                                        for k in criteria.keys():
	                                                print "&" + k + "=" + criteria[k],
	                                        print "&groupby=none&sid=" + str(i[0]) + "\">",
	                                        print str(i[j]) + "</a></td>",
	                                elif j == 4:
	                                        print "<td><a href=\"./summary.py?",
	                                        for k in criteria.keys():
	                                                print "&" + k + "=" + criteria[k],
	                                        print "&ipdst=distinct&groupby=ip\">",
	                                        print str(i[j]) + "</a></td>",
	                                elif j == 5:
	                                        print "<td><a href=\"./summary.py?",
	                                        for k in criteria.keys():
							if (k != "ip") and (k != "ipsrc") and (k != "ipdst"):
		                                                print "&" + k + "=" + criteria[k],
	                                        print "&ipsrc=distinct&groupby=ip\">",
	                                        print str(i[j]) + "</a></td>",
	                        print "</tr>"
			print "<tr><td align=right colspan=6 border=0>"
			print "<form method=post action=\"summary.py\">",
			for z in form.keys():
				if z != 'skipgroups':
					print "<input type=hidden name=\"" + z + "\" value=\"" + form[z].value + "\">",
			if criteria.has_key('skipgroups') and form.has_key('numgroups'):
				print "<input type=hidden name=\"skipgroups\" value=\"" + str(int(criteria['skipgroups']) + int(form['numgroups'].value)) + "\">",
			elif criteria.has_key('skipgroups'):
				print "<input type=hidden name=\"skipgroups\" value=\"" + str(int(criteria['skipgroups']) + int(options['entrieslimit'])) + "\">",
			else:
				print "<input type=hidden name=\"skipgroups\" value=\"" + str(0) + "\">",
			print "<input value=\"Next\" type=submit></form></td></tr>",
	                print "</table>"
		elif form['groupby'].value == "ip":
			print "<table width=100% border=1>"
			print "<tr><td align=right colspan=4 border=0>"
			print "<form method=post action=\"summary.py\">",
			for z in form.keys():
				if z != 'skipgroups':
					print "<input type=hidden name=\"" + z + "\" value=\"" + form[z].value + "\">",
			if criteria.has_key('skipgroups') and form.has_key('numgroups'):
				print "<input type=hidden name=\"skipgroups\" value=\"" + str(int(criteria['skipgroups']) + int(form['numgroups'].value)) + "\">",
			elif criteria.has_key('skipgroups'):
				print "<input type=hidden name=\"skipgroups\" value=\"" + str(int(criteria['skipgroups']) + int(options['entrieslimit'])) + "\">",
			else:
				print "<input type=hidden name=\"skipgroups\" value=\"" + str(0) + "\">",
			print "<input value=\"Next\" type=submit></form></td></tr>",
			if form.has_key('ipsrc'):
		                print "<tr bgcolor=#dddddd><td>Dst</td><td>Sig name</td><td>Total Events</td><td>Proto</td></tr>"
			elif form.has_key('ipdst'):
				print "<tr bgcolor=#dddddd><td>Src</td><td>Sig name</td><td>Total Events</td><td>Proto</td></tr>"
	                for i in temp:
				counter = 0
	                        print "<tr>",
	                        for j in range(0,4):
					if j == 0:  
						print "<td><a href=\"./summary.py?",
	                                        for k in criteria.keys():
							if (k != "ip") and (k != "ipsrc") and (k != "ipdst"):
		                                                print "&" + k + "=" + criteria[k],
	                                        print "&groupby=none&ipdst=distinct&ip=" + str(i[j])
						print "\">",
	                                        print str(i[j]) + "</a>",
						if options.has_key("resolvedns") and options["resolvedns"]=="yes":
							print dnslookup(i[j])
						print "</td>"
	                                elif j == 1:
						print "<td><a href=\"./summary.py?",
	                                        for k in criteria.keys():
	                                                print "&" + k + "=" + criteria[k],
	                                        print "&groupby=signatures\">",
	                                        print str(i[j]) + "</a></td>",
	                                elif j == 2:
	                                        print "<td><a href=\"./summary.py?",
	                                        for k in criteria.keys():
						       if (k != "ip") and (k != "ipsrc") and (k != "ipdst"):
                                                               print "&" + k + "=" + criteria[k],
                                                       elif (k == "ipsrc") and criteria[k] == 'distinct':
                                                               print "&ipdst=distinct",
                                                       elif (k == "ipdst") and criteria[k] == 'distinct':
                                                                 print "&ipsrc=distinct",
	                                        print "&groupby=none&ip=" + str(i[0])  + "\">",
	                                        print str(i[j]) + "</a></td>",
        	                        elif j == 3:
		                                print "<td>" + str(i[j]) + "</td>",
	                        print "</tr>"
			print "<tr><td align=right colspan=4 border=0>"
			print "<form method=post action=\"summary.py\">",
			for z in form.keys():
				if z != 'skipgroups':
					print "<input type=hidden name=\"" + z + "\" value=\"" + form[z].value + "\">",
			if criteria.has_key('skipgroups') and form.has_key('numgroups'):
				print "<input type=hidden name=\"skipgroups\" value=\"" + str(int(criteria['skipgroups']) + int(form['numgroups'].value)) + "\">",
			elif criteria.has_key('skipgroups'):
				print "<input type=hidden name=\"skipgroups\" value=\"" + str(int(criteria['skipgroups']) + int(options['entrieslimit'])) + "\">",
			else:
				print "<input type=hidden name=\"skipgroups\" value=\"" + str(0) + "\">",
			print "<input value=\"Next\" type=submit></form></td></tr>",
	                print "</table>"

		printtail()	
	
main()
